/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package display

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type Display struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	Monitors      *dbusPropertyDisplayMonitors
	ScreenWidth   *dbusPropertyDisplayScreenWidth
	ScreenHeight  *dbusPropertyDisplayScreenHeight
	Primary       *dbusPropertyDisplayPrimary
	PrimaryRect   *dbusPropertyDisplayPrimaryRect
	DisplayMode   *dbusPropertyDisplayDisplayMode
	BuiltinOutput *dbusPropertyDisplayBuiltinOutput
	HasChanged    *dbusPropertyDisplayHasChanged
	Brightness    *dbusPropertyDisplayBrightness
}

func (obj *Display) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *Display) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyDisplay(obj *Display) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.Monitors.Reset()
	obj.ScreenWidth.Reset()
	obj.ScreenHeight.Reset()
	obj.Primary.Reset()
	obj.PrimaryRect.Reset()
	obj.DisplayMode.Reset()
	obj.BuiltinOutput.Reset()
	obj.HasChanged.Reset()
	obj.Brightness.Reset()
}

func (obj *Display) SwitchMode(arg0 int16, arg1 string) (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Display.SwitchMode", 0, arg0, arg1).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Display) Apply() (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Display.Apply", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Display) ChangeBrightness(arg0 string, arg1 float64) (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Display.ChangeBrightness", 0, arg0, arg1).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Display) JoinMonitor(arg0 string, arg1 string) (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Display.JoinMonitor", 0, arg0, arg1).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Display) QueryCurrentPlanName() (arg0 string, _err error) {
	_err = obj.core.Call("com.deepin.daemon.Display.QueryCurrentPlanName", 0).Store(&arg0)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Display) Reset() (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Display.Reset", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Display) ResetBrightness(arg0 string) (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Display.ResetBrightness", 0, arg0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Display) ResetChanges() (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Display.ResetChanges", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Display) SaveChanges() (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Display.SaveChanges", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Display) SetBrightness(arg0 string, arg1 float64) (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Display.SetBrightness", 0, arg0, arg1).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Display) SetPrimary(arg0 string) (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Display.SetPrimary", 0, arg0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Display) SplitMonitor(arg0 string) (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Display.SplitMonitor", 0, arg0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Display) ConnectPrimaryChanged(callback func(arg0 []interface{})) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='com.deepin.daemon.Display',sender='"+obj.DestName+"',member='PrimaryChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "com.deepin.daemon.Display.PrimaryChanged" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*[]interface{})(nil)).Elem() {
				continue
			}

			callback(v.Body[0].([]interface{}))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyDisplayMonitors struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDisplayMonitors) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Display.Monitors is not writable")
}

func (this *dbusPropertyDisplayMonitors) Get() []dbus.ObjectPath {
	return this.GetValue().([]dbus.ObjectPath)
}
func (this *dbusPropertyDisplayMonitors) GetValue() interface{} /*[]dbus.ObjectPath*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Display", "Monitors").Store(&r)
	if err == nil && r.Signature().String() == "ao" {
		return r.Value().([]dbus.ObjectPath)
	} else {
		fmt.Println("dbusProperty:Monitors error:", err, "at com.deepin.daemon.Display")
		return *new([]dbus.ObjectPath)
	}
}
func (this *dbusPropertyDisplayMonitors) GetType() reflect.Type {
	return reflect.TypeOf((*[]dbus.ObjectPath)(nil)).Elem()
}

type dbusPropertyDisplayScreenWidth struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDisplayScreenWidth) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Display.ScreenWidth is not writable")
}

func (this *dbusPropertyDisplayScreenWidth) Get() uint16 {
	return this.GetValue().(uint16)
}
func (this *dbusPropertyDisplayScreenWidth) GetValue() interface{} /*uint16*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Display", "ScreenWidth").Store(&r)
	if err == nil && r.Signature().String() == "q" {
		return r.Value().(uint16)
	} else {
		fmt.Println("dbusProperty:ScreenWidth error:", err, "at com.deepin.daemon.Display")
		return *new(uint16)
	}
}
func (this *dbusPropertyDisplayScreenWidth) GetType() reflect.Type {
	return reflect.TypeOf((*uint16)(nil)).Elem()
}

type dbusPropertyDisplayScreenHeight struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDisplayScreenHeight) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Display.ScreenHeight is not writable")
}

func (this *dbusPropertyDisplayScreenHeight) Get() uint16 {
	return this.GetValue().(uint16)
}
func (this *dbusPropertyDisplayScreenHeight) GetValue() interface{} /*uint16*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Display", "ScreenHeight").Store(&r)
	if err == nil && r.Signature().String() == "q" {
		return r.Value().(uint16)
	} else {
		fmt.Println("dbusProperty:ScreenHeight error:", err, "at com.deepin.daemon.Display")
		return *new(uint16)
	}
}
func (this *dbusPropertyDisplayScreenHeight) GetType() reflect.Type {
	return reflect.TypeOf((*uint16)(nil)).Elem()
}

type dbusPropertyDisplayPrimary struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDisplayPrimary) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Display.Primary is not writable")
}

func (this *dbusPropertyDisplayPrimary) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDisplayPrimary) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Display", "Primary").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:Primary error:", err, "at com.deepin.daemon.Display")
		return *new(string)
	}
}
func (this *dbusPropertyDisplayPrimary) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDisplayPrimaryRect struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDisplayPrimaryRect) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Display.PrimaryRect is not writable")
}

func (this *dbusPropertyDisplayPrimaryRect) Get() []interface{} {
	return this.GetValue().([]interface{})
}
func (this *dbusPropertyDisplayPrimaryRect) GetValue() interface{} /*[]interface {}*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Display", "PrimaryRect").Store(&r)
	if err == nil && r.Signature().String() == "(nnqq)" {
		return r.Value().([]interface{})
	} else {
		fmt.Println("dbusProperty:PrimaryRect error:", err, "at com.deepin.daemon.Display")
		return *new([]interface{})
	}
}
func (this *dbusPropertyDisplayPrimaryRect) GetType() reflect.Type {
	return reflect.TypeOf((*[]interface{})(nil)).Elem()
}

type dbusPropertyDisplayDisplayMode struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDisplayDisplayMode) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Display.DisplayMode is not writable")
}

func (this *dbusPropertyDisplayDisplayMode) Get() int16 {
	return this.GetValue().(int16)
}
func (this *dbusPropertyDisplayDisplayMode) GetValue() interface{} /*int16*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Display", "DisplayMode").Store(&r)
	if err == nil && r.Signature().String() == "n" {
		return r.Value().(int16)
	} else {
		fmt.Println("dbusProperty:DisplayMode error:", err, "at com.deepin.daemon.Display")
		return *new(int16)
	}
}
func (this *dbusPropertyDisplayDisplayMode) GetType() reflect.Type {
	return reflect.TypeOf((*int16)(nil)).Elem()
}

type dbusPropertyDisplayBuiltinOutput struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDisplayBuiltinOutput) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Display.BuiltinOutput is not writable")
}

func (this *dbusPropertyDisplayBuiltinOutput) Get() dbus.ObjectPath {
	return this.GetValue().(dbus.ObjectPath)
}
func (this *dbusPropertyDisplayBuiltinOutput) GetValue() interface{} /*dbus.ObjectPath*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Display", "BuiltinOutput").Store(&r)
	if err == nil && r.Signature().String() == "o" {
		return r.Value().(dbus.ObjectPath)
	} else {
		fmt.Println("dbusProperty:BuiltinOutput error:", err, "at com.deepin.daemon.Display")
		return *new(dbus.ObjectPath)
	}
}
func (this *dbusPropertyDisplayBuiltinOutput) GetType() reflect.Type {
	return reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem()
}

type dbusPropertyDisplayHasChanged struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDisplayHasChanged) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Display.HasChanged is not writable")
}

func (this *dbusPropertyDisplayHasChanged) Get() bool {
	return this.GetValue().(bool)
}
func (this *dbusPropertyDisplayHasChanged) GetValue() interface{} /*bool*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Display", "HasChanged").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool)
	} else {
		fmt.Println("dbusProperty:HasChanged error:", err, "at com.deepin.daemon.Display")
		return *new(bool)
	}
}
func (this *dbusPropertyDisplayHasChanged) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

type dbusPropertyDisplayBrightness struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDisplayBrightness) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Display.Brightness is not writable")
}

func (this *dbusPropertyDisplayBrightness) Get() map[string]float64 {
	return this.GetValue().(map[string]float64)
}
func (this *dbusPropertyDisplayBrightness) GetValue() interface{} /*map[string]float64*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Display", "Brightness").Store(&r)
	if err == nil && r.Signature().String() == "a{sd}" {
		return r.Value().(map[string]float64)
	} else {
		fmt.Println("dbusProperty:Brightness error:", err, "at com.deepin.daemon.Display")
		return *new(map[string]float64)
	}
}
func (this *dbusPropertyDisplayBrightness) GetType() reflect.Type {
	return reflect.TypeOf((*map[string]float64)(nil)).Elem()
}

func NewDisplay(destName string, path dbus.ObjectPath) (*Display, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &Display{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.Monitors = &dbusPropertyDisplayMonitors{&property.BaseObserver{}, core}
	obj.ScreenWidth = &dbusPropertyDisplayScreenWidth{&property.BaseObserver{}, core}
	obj.ScreenHeight = &dbusPropertyDisplayScreenHeight{&property.BaseObserver{}, core}
	obj.Primary = &dbusPropertyDisplayPrimary{&property.BaseObserver{}, core}
	obj.PrimaryRect = &dbusPropertyDisplayPrimaryRect{&property.BaseObserver{}, core}
	obj.DisplayMode = &dbusPropertyDisplayDisplayMode{&property.BaseObserver{}, core}
	obj.BuiltinOutput = &dbusPropertyDisplayBuiltinOutput{&property.BaseObserver{}, core}
	obj.HasChanged = &dbusPropertyDisplayHasChanged{&property.BaseObserver{}, core}
	obj.Brightness = &dbusPropertyDisplayBrightness{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='com.deepin.daemon.Display',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "com.deepin.daemon.Display" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "Monitors" {
						obj.Monitors.Notify()

					} else if key == "ScreenWidth" {
						obj.ScreenWidth.Notify()

					} else if key == "ScreenHeight" {
						obj.ScreenHeight.Notify()

					} else if key == "Primary" {
						obj.Primary.Notify()

					} else if key == "PrimaryRect" {
						obj.PrimaryRect.Notify()

					} else if key == "DisplayMode" {
						obj.DisplayMode.Notify()

					} else if key == "BuiltinOutput" {
						obj.BuiltinOutput.Notify()

					} else if key == "HasChanged" {
						obj.HasChanged.Notify()

					} else if key == "Brightness" {
						obj.Brightness.Notify()
					}
				}
			} else if v.Name == "com.deepin.daemon.Display.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "Monitors" {
						obj.Monitors.Notify()

					} else if key == "ScreenWidth" {
						obj.ScreenWidth.Notify()

					} else if key == "ScreenHeight" {
						obj.ScreenHeight.Notify()

					} else if key == "Primary" {
						obj.Primary.Notify()

					} else if key == "PrimaryRect" {
						obj.PrimaryRect.Notify()

					} else if key == "DisplayMode" {
						obj.DisplayMode.Notify()

					} else if key == "BuiltinOutput" {
						obj.BuiltinOutput.Notify()

					} else if key == "HasChanged" {
						obj.HasChanged.Notify()

					} else if key == "Brightness" {
						obj.Brightness.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *Display) { DestroyDisplay(_obj) })
	return obj, nil
}
