/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package keybinding

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type KeyBinding struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	SystemList      *dbusPropertyKeyBindingSystemList
	WindowList      *dbusPropertyKeyBindingWindowList
	WorkspaceList   *dbusPropertyKeyBindingWorkspaceList
	CustomList      *dbusPropertyKeyBindingCustomList
	ConflictValid   *dbusPropertyKeyBindingConflictValid
	ConflictInvalid *dbusPropertyKeyBindingConflictInvalid
}

func (obj *KeyBinding) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *KeyBinding) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyKeyBinding(obj *KeyBinding) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.SystemList.Reset()
	obj.WindowList.Reset()
	obj.WorkspaceList.Reset()
	obj.CustomList.Reset()
	obj.ConflictValid.Reset()
	obj.ConflictInvalid.Reset()
}

func (obj *KeyBinding) AddCustomShortcut(arg0 string, arg1 string) (arg2 int32, arg3 bool, _err error) {
	_err = obj.core.Call("com.deepin.daemon.KeyBinding.AddCustomShortcut", 0, arg0, arg1).Store(&arg2, &arg3)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *KeyBinding) AddCustomShortcutCheck(arg0 string, arg1 string, arg2 string) (arg3 int32, arg4 string, arg5 []int32, _err error) {
	_err = obj.core.Call("com.deepin.daemon.KeyBinding.AddCustomShortcutCheck", 0, arg0, arg1, arg2).Store(&arg3, &arg4, &arg5)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *KeyBinding) CheckShortcutConflict(arg0 string) (arg1 string, arg2 []int32, _err error) {
	_err = obj.core.Call("com.deepin.daemon.KeyBinding.CheckShortcutConflict", 0, arg0).Store(&arg1, &arg2)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *KeyBinding) DeleteCustomShortcut(arg0 int32) (_err error) {
	_err = obj.core.Call("com.deepin.daemon.KeyBinding.DeleteCustomShortcut", 0, arg0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *KeyBinding) GrabKbdAndMouse() (_err error) {
	_err = obj.core.Call("com.deepin.daemon.KeyBinding.GrabKbdAndMouse", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *KeyBinding) GrabSignalShortcut(arg0 string, arg1 string, arg2 bool) (_err error) {
	_err = obj.core.Call("com.deepin.daemon.KeyBinding.GrabSignalShortcut", 0, arg0, arg1, arg2).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *KeyBinding) ModifyShortcut(arg0 int32, arg1 string) (arg2 string, arg3 []int32, _err error) {
	_err = obj.core.Call("com.deepin.daemon.KeyBinding.ModifyShortcut", 0, arg0, arg1).Store(&arg2, &arg3)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *KeyBinding) Reset() (arg0 bool, _err error) {
	_err = obj.core.Call("com.deepin.daemon.KeyBinding.Reset", 0).Store(&arg0)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *KeyBinding) ConnectKeyPressEvent(callback func(arg0 string)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='com.deepin.daemon.KeyBinding',sender='"+obj.DestName+"',member='KeyPressEvent'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "com.deepin.daemon.KeyBinding.KeyPressEvent" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*string)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(string))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

func (obj *KeyBinding) ConnectKeyReleaseEvent(callback func(arg0 string)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='com.deepin.daemon.KeyBinding',sender='"+obj.DestName+"',member='KeyReleaseEvent'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "com.deepin.daemon.KeyBinding.KeyReleaseEvent" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*string)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(string))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyKeyBindingSystemList struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyKeyBindingSystemList) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.KeyBinding.SystemList is not writable")
}

func (this *dbusPropertyKeyBindingSystemList) Get() [][]interface{} {
	return this.GetValue().([][]interface{})
}
func (this *dbusPropertyKeyBindingSystemList) GetValue() interface{} /*[][]interface {}*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.KeyBinding", "SystemList").Store(&r)
	if err == nil && r.Signature().String() == "a(iss)" {
		return r.Value().([][]interface{})
	} else {
		fmt.Println("dbusProperty:SystemList error:", err, "at com.deepin.daemon.KeyBinding")
		return *new([][]interface{})
	}
}
func (this *dbusPropertyKeyBindingSystemList) GetType() reflect.Type {
	return reflect.TypeOf((*[][]interface{})(nil)).Elem()
}

type dbusPropertyKeyBindingWindowList struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyKeyBindingWindowList) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.KeyBinding.WindowList is not writable")
}

func (this *dbusPropertyKeyBindingWindowList) Get() [][]interface{} {
	return this.GetValue().([][]interface{})
}
func (this *dbusPropertyKeyBindingWindowList) GetValue() interface{} /*[][]interface {}*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.KeyBinding", "WindowList").Store(&r)
	if err == nil && r.Signature().String() == "a(iss)" {
		return r.Value().([][]interface{})
	} else {
		fmt.Println("dbusProperty:WindowList error:", err, "at com.deepin.daemon.KeyBinding")
		return *new([][]interface{})
	}
}
func (this *dbusPropertyKeyBindingWindowList) GetType() reflect.Type {
	return reflect.TypeOf((*[][]interface{})(nil)).Elem()
}

type dbusPropertyKeyBindingWorkspaceList struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyKeyBindingWorkspaceList) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.KeyBinding.WorkspaceList is not writable")
}

func (this *dbusPropertyKeyBindingWorkspaceList) Get() [][]interface{} {
	return this.GetValue().([][]interface{})
}
func (this *dbusPropertyKeyBindingWorkspaceList) GetValue() interface{} /*[][]interface {}*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.KeyBinding", "WorkspaceList").Store(&r)
	if err == nil && r.Signature().String() == "a(iss)" {
		return r.Value().([][]interface{})
	} else {
		fmt.Println("dbusProperty:WorkspaceList error:", err, "at com.deepin.daemon.KeyBinding")
		return *new([][]interface{})
	}
}
func (this *dbusPropertyKeyBindingWorkspaceList) GetType() reflect.Type {
	return reflect.TypeOf((*[][]interface{})(nil)).Elem()
}

type dbusPropertyKeyBindingCustomList struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyKeyBindingCustomList) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.KeyBinding.CustomList is not writable")
}

func (this *dbusPropertyKeyBindingCustomList) Get() [][]interface{} {
	return this.GetValue().([][]interface{})
}
func (this *dbusPropertyKeyBindingCustomList) GetValue() interface{} /*[][]interface {}*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.KeyBinding", "CustomList").Store(&r)
	if err == nil && r.Signature().String() == "a(iss)" {
		return r.Value().([][]interface{})
	} else {
		fmt.Println("dbusProperty:CustomList error:", err, "at com.deepin.daemon.KeyBinding")
		return *new([][]interface{})
	}
}
func (this *dbusPropertyKeyBindingCustomList) GetType() reflect.Type {
	return reflect.TypeOf((*[][]interface{})(nil)).Elem()
}

type dbusPropertyKeyBindingConflictValid struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyKeyBindingConflictValid) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.KeyBinding.ConflictValid is not writable")
}

func (this *dbusPropertyKeyBindingConflictValid) Get() []int32 {
	return this.GetValue().([]int32)
}
func (this *dbusPropertyKeyBindingConflictValid) GetValue() interface{} /*[]int32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.KeyBinding", "ConflictValid").Store(&r)
	if err == nil && r.Signature().String() == "ai" {
		return r.Value().([]int32)
	} else {
		fmt.Println("dbusProperty:ConflictValid error:", err, "at com.deepin.daemon.KeyBinding")
		return *new([]int32)
	}
}
func (this *dbusPropertyKeyBindingConflictValid) GetType() reflect.Type {
	return reflect.TypeOf((*[]int32)(nil)).Elem()
}

type dbusPropertyKeyBindingConflictInvalid struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyKeyBindingConflictInvalid) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.KeyBinding.ConflictInvalid is not writable")
}

func (this *dbusPropertyKeyBindingConflictInvalid) Get() []int32 {
	return this.GetValue().([]int32)
}
func (this *dbusPropertyKeyBindingConflictInvalid) GetValue() interface{} /*[]int32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.KeyBinding", "ConflictInvalid").Store(&r)
	if err == nil && r.Signature().String() == "ai" {
		return r.Value().([]int32)
	} else {
		fmt.Println("dbusProperty:ConflictInvalid error:", err, "at com.deepin.daemon.KeyBinding")
		return *new([]int32)
	}
}
func (this *dbusPropertyKeyBindingConflictInvalid) GetType() reflect.Type {
	return reflect.TypeOf((*[]int32)(nil)).Elem()
}

func NewKeyBinding(destName string, path dbus.ObjectPath) (*KeyBinding, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &KeyBinding{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.SystemList = &dbusPropertyKeyBindingSystemList{&property.BaseObserver{}, core}
	obj.WindowList = &dbusPropertyKeyBindingWindowList{&property.BaseObserver{}, core}
	obj.WorkspaceList = &dbusPropertyKeyBindingWorkspaceList{&property.BaseObserver{}, core}
	obj.CustomList = &dbusPropertyKeyBindingCustomList{&property.BaseObserver{}, core}
	obj.ConflictValid = &dbusPropertyKeyBindingConflictValid{&property.BaseObserver{}, core}
	obj.ConflictInvalid = &dbusPropertyKeyBindingConflictInvalid{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='com.deepin.daemon.KeyBinding',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "com.deepin.daemon.KeyBinding" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "SystemList" {
						obj.SystemList.Notify()

					} else if key == "WindowList" {
						obj.WindowList.Notify()

					} else if key == "WorkspaceList" {
						obj.WorkspaceList.Notify()

					} else if key == "CustomList" {
						obj.CustomList.Notify()

					} else if key == "ConflictValid" {
						obj.ConflictValid.Notify()

					} else if key == "ConflictInvalid" {
						obj.ConflictInvalid.Notify()
					}
				}
			} else if v.Name == "com.deepin.daemon.KeyBinding.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "SystemList" {
						obj.SystemList.Notify()

					} else if key == "WindowList" {
						obj.WindowList.Notify()

					} else if key == "WorkspaceList" {
						obj.WorkspaceList.Notify()

					} else if key == "CustomList" {
						obj.CustomList.Notify()

					} else if key == "ConflictValid" {
						obj.ConflictValid.Notify()

					} else if key == "ConflictInvalid" {
						obj.ConflictInvalid.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *KeyBinding) { DestroyKeyBinding(_obj) })
	return obj, nil
}
