/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package mime

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type MediaMount struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	AutoMountOpen *dbusPropertyMediaMountAutoMountOpen
}

func (obj *MediaMount) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *MediaMount) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyMediaMount(obj *MediaMount) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.AutoMountOpen.Reset()
}

func (obj *MediaMount) DefaultMediaAppByMime(arg0 string) (arg1 []interface{}, _err error) {
	_err = obj.core.Call("com.deepin.daemon.MediaMount.DefaultMediaAppByMime", 0, arg0).Store(&arg1)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *MediaMount) MediaAppListByMime(arg0 string) (arg1 [][]interface{}, _err error) {
	_err = obj.core.Call("com.deepin.daemon.MediaMount.MediaAppListByMime", 0, arg0).Store(&arg1)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *MediaMount) SetMediaAppByMime(arg0 string, arg1 string) (_err error) {
	_err = obj.core.Call("com.deepin.daemon.MediaMount.SetMediaAppByMime", 0, arg0, arg1).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *MediaMount) Reset() (arg0 bool, _err error) {
	_err = obj.core.Call("com.deepin.daemon.MediaMount.Reset", 0).Store(&arg0)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *MediaMount) ConnectMediaActionChanged(callback func()) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='com.deepin.daemon.MediaMount',sender='"+obj.DestName+"',member='MediaActionChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "com.deepin.daemon.MediaMount.MediaActionChanged" || 0 != len(v.Body) {
				continue
			}

			callback()
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyMediaMountAutoMountOpen struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyMediaMountAutoMountOpen) SetValue(v interface{} /*bool*/) {
	if reflect.TypeOf(v) == reflect.TypeOf((*bool)(nil)).Elem() {
		this.core.Call("org.freedesktop.DBus.Properties.Set", 0, "com.deepin.daemon.MediaMount", "AutoMountOpen", dbus.MakeVariant(v))
	} else {
		fmt.Println("The property AutoMountOpen of com.deepin.daemon.MediaMount is an bool but Set with an ", reflect.TypeOf(v))
	}
}
func (this *dbusPropertyMediaMountAutoMountOpen) Set(v bool) {
	this.SetValue(v)
}

func (this *dbusPropertyMediaMountAutoMountOpen) Get() bool {
	return this.GetValue().(bool)
}
func (this *dbusPropertyMediaMountAutoMountOpen) GetValue() interface{} /*bool*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.MediaMount", "AutoMountOpen").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool)
	} else {
		fmt.Println("dbusProperty:AutoMountOpen error:", err, "at com.deepin.daemon.MediaMount")
		return *new(bool)
	}
}
func (this *dbusPropertyMediaMountAutoMountOpen) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

func NewMediaMount(destName string, path dbus.ObjectPath) (*MediaMount, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &MediaMount{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.AutoMountOpen = &dbusPropertyMediaMountAutoMountOpen{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='com.deepin.daemon.MediaMount',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "com.deepin.daemon.MediaMount" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "AutoMountOpen" {
						obj.AutoMountOpen.Notify()
					}
				}
			} else if v.Name == "com.deepin.daemon.MediaMount.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "AutoMountOpen" {
						obj.AutoMountOpen.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *MediaMount) { DestroyMediaMount(_obj) })
	return obj, nil
}
