/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package client

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type RemotingClient struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	GetStatus_ *dbusPropertyRemotingClientGetStatus_
}

func (obj *RemotingClient) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *RemotingClient) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyRemotingClient(obj *RemotingClient) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.GetStatus_.Reset()
}

func (obj *RemotingClient) Start() (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Remoting.Client.Start", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *RemotingClient) Stop() (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Remoting.Client.Stop", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *RemotingClient) Connect(remote_peer_id string) (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Remoting.Client.Connect", 0, remote_peer_id).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *RemotingClient) GetStatus() (arg0 int32, _err error) {
	_err = obj.core.Call("com.deepin.daemon.Remoting.Client.GetStatus", 0).Store(&arg0)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *RemotingClient) ConnectStatusChanged(callback func(status int32)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='com.deepin.daemon.Remoting.Client',sender='"+obj.DestName+"',member='StatusChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "com.deepin.daemon.Remoting.Client.StatusChanged" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*int32)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(int32))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyRemotingClientGetStatus_ struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyRemotingClientGetStatus_) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Remoting.Client.GetStatus_ is not writable")
}

func (this *dbusPropertyRemotingClientGetStatus_) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyRemotingClientGetStatus_) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Remoting.Client", "GetStatus_").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:GetStatus_ error:", err, "at com.deepin.daemon.Remoting.Client")
		return *new(string)
	}
}
func (this *dbusPropertyRemotingClientGetStatus_) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

func NewRemotingClient(destName string, path dbus.ObjectPath) (*RemotingClient, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &RemotingClient{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.GetStatus_ = &dbusPropertyRemotingClientGetStatus_{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='com.deepin.daemon.Remoting.Client',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "com.deepin.daemon.Remoting.Client" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "GetStatus_" {
						obj.GetStatus_.Notify()
					}
				}
			} else if v.Name == "com.deepin.daemon.Remoting.Client.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "GetStatus_" {
						obj.GetStatus_.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *RemotingClient) { DestroyRemotingClient(_obj) })
	return obj, nil
}
