/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package feedback

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type Feedback struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	WorkingSet *dbusPropertyFeedbackWorkingSet
}

func (obj *Feedback) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *Feedback) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyFeedback(obj *Feedback) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.WorkingSet.Reset()
}

func (obj *Feedback) GenerateReport(arg0 string, arg1 bool) (arg2 uint64, _err error) {
	_err = obj.core.Call("com.deepin.Feedback.GenerateReport", 0, arg0, arg1).Store(&arg2)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Feedback) GetCategories() (arg0 string, _err error) {
	_err = obj.core.Call("com.deepin.Feedback.GetCategories", 0).Store(&arg0)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Feedback) ConnectGenerateReportFinished(callback func(arg0 uint64, arg1 string)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='com.deepin.Feedback',sender='"+obj.DestName+"',member='GenerateReportFinished'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "com.deepin.Feedback.GenerateReportFinished" || 2 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*uint64)(nil)).Elem() {
				continue
			}
			if reflect.TypeOf(v.Body[1]) != reflect.TypeOf((*string)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(uint64), v.Body[1].(string))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyFeedbackWorkingSet struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyFeedbackWorkingSet) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.Feedback.WorkingSet is not writable")
}

func (this *dbusPropertyFeedbackWorkingSet) Get() map[uint64]bool {
	return this.GetValue().(map[uint64]bool)
}
func (this *dbusPropertyFeedbackWorkingSet) GetValue() interface{} /*map[uint64]bool*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.Feedback", "WorkingSet").Store(&r)
	if err == nil && r.Signature().String() == "a{tb}" {
		return r.Value().(map[uint64]bool)
	} else {
		fmt.Println("dbusProperty:WorkingSet error:", err, "at com.deepin.Feedback")
		return *new(map[uint64]bool)
	}
}
func (this *dbusPropertyFeedbackWorkingSet) GetType() reflect.Type {
	return reflect.TypeOf((*map[uint64]bool)(nil)).Elem()
}

func NewFeedback(destName string, path dbus.ObjectPath) (*Feedback, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &Feedback{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.WorkingSet = &dbusPropertyFeedbackWorkingSet{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='com.deepin.Feedback',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "com.deepin.Feedback" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "WorkingSet" {
						obj.WorkingSet.Notify()
					}
				}
			} else if v.Name == "com.deepin.Feedback.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "WorkingSet" {
						obj.WorkingSet.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *Feedback) { DestroyFeedback(_obj) })
	return obj, nil
}
