/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package modemmanager1

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type ModemMessaging struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	SupportedStorages *dbusPropertyModemMessagingSupportedStorages
	DefaultStorage    *dbusPropertyModemMessagingDefaultStorage
}

func (obj *ModemMessaging) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *ModemMessaging) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyModemMessaging(obj *ModemMessaging) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.SupportedStorages.Reset()
	obj.DefaultStorage.Reset()
}

func (obj *ModemMessaging) List() (result []dbus.ObjectPath, _err error) {
	_err = obj.core.Call("org.freedesktop.ModemManager1.Modem.Messaging.List", 0).Store(&result)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *ModemMessaging) Delete(path dbus.ObjectPath) (_err error) {
	_err = obj.core.Call("org.freedesktop.ModemManager1.Modem.Messaging.Delete", 0, path).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *ModemMessaging) Create(properties map[string]dbus.Variant) (path dbus.ObjectPath, _err error) {
	_err = obj.core.Call("org.freedesktop.ModemManager1.Modem.Messaging.Create", 0, properties).Store(&path)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *ModemMessaging) ConnectAdded(callback func(path dbus.ObjectPath, received bool)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.ModemManager1.Modem.Messaging',sender='"+obj.DestName+"',member='Added'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.ModemManager1.Modem.Messaging.Added" || 2 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem() {
				continue
			}
			if reflect.TypeOf(v.Body[1]) != reflect.TypeOf((*bool)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(dbus.ObjectPath), v.Body[1].(bool))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

func (obj *ModemMessaging) ConnectDeleted(callback func(path dbus.ObjectPath)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.ModemManager1.Modem.Messaging',sender='"+obj.DestName+"',member='Deleted'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.ModemManager1.Modem.Messaging.Deleted" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(dbus.ObjectPath))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyModemMessagingSupportedStorages struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyModemMessagingSupportedStorages) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.ModemManager1.Modem.Messaging.SupportedStorages is not writable")
}

func (this *dbusPropertyModemMessagingSupportedStorages) Get() []uint32 {
	return this.GetValue().([]uint32)
}
func (this *dbusPropertyModemMessagingSupportedStorages) GetValue() interface{} /*[]uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.ModemManager1.Modem.Messaging", "SupportedStorages").Store(&r)
	if err == nil && r.Signature().String() == "au" {
		return r.Value().([]uint32)
	} else {
		fmt.Println("dbusProperty:SupportedStorages error:", err, "at org.freedesktop.ModemManager1.Modem.Messaging")
		return *new([]uint32)
	}
}
func (this *dbusPropertyModemMessagingSupportedStorages) GetType() reflect.Type {
	return reflect.TypeOf((*[]uint32)(nil)).Elem()
}

type dbusPropertyModemMessagingDefaultStorage struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyModemMessagingDefaultStorage) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.ModemManager1.Modem.Messaging.DefaultStorage is not writable")
}

func (this *dbusPropertyModemMessagingDefaultStorage) Get() uint32 {
	return this.GetValue().(uint32)
}
func (this *dbusPropertyModemMessagingDefaultStorage) GetValue() interface{} /*uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.ModemManager1.Modem.Messaging", "DefaultStorage").Store(&r)
	if err == nil && r.Signature().String() == "u" {
		return r.Value().(uint32)
	} else {
		fmt.Println("dbusProperty:DefaultStorage error:", err, "at org.freedesktop.ModemManager1.Modem.Messaging")
		return *new(uint32)
	}
}
func (this *dbusPropertyModemMessagingDefaultStorage) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

func NewModemMessaging(destName string, path dbus.ObjectPath) (*ModemMessaging, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &ModemMessaging{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.SupportedStorages = &dbusPropertyModemMessagingSupportedStorages{&property.BaseObserver{}, core}
	obj.DefaultStorage = &dbusPropertyModemMessagingDefaultStorage{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.ModemManager1.Modem.Messaging',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.ModemManager1.Modem.Messaging" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "SupportedStorages" {
						obj.SupportedStorages.Notify()

					} else if key == "DefaultStorage" {
						obj.DefaultStorage.Notify()
					}
				}
			} else if v.Name == "org.freedesktop.ModemManager1.Modem.Messaging.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "SupportedStorages" {
						obj.SupportedStorages.Notify()

					} else if key == "DefaultStorage" {
						obj.DefaultStorage.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *ModemMessaging) { DestroyModemMessaging(_obj) })
	return obj, nil
}
