/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package networkmanager

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type DeviceAdsl struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	Carrier *dbusPropertyDeviceAdslCarrier
}

func (obj *DeviceAdsl) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *DeviceAdsl) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyDeviceAdsl(obj *DeviceAdsl) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.Carrier.Reset()
}

func (obj *DeviceAdsl) ConnectPropertiesChanged(callback func(properties map[string]dbus.Variant)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.NetworkManager.Device.Adsl',sender='"+obj.DestName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.Device.Adsl.PropertiesChanged" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*map[string]dbus.Variant)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(map[string]dbus.Variant))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyDeviceAdslCarrier struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceAdslCarrier) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Adsl.Carrier is not writable")
}

func (this *dbusPropertyDeviceAdslCarrier) Get() bool {
	return this.GetValue().(bool)
}
func (this *dbusPropertyDeviceAdslCarrier) GetValue() interface{} /*bool*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Adsl", "Carrier").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool)
	} else {
		fmt.Println("dbusProperty:Carrier error:", err, "at org.freedesktop.NetworkManager.Device.Adsl")
		return *new(bool)
	}
}
func (this *dbusPropertyDeviceAdslCarrier) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

func NewDeviceAdsl(destName string, path dbus.ObjectPath) (*DeviceAdsl, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &DeviceAdsl{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.Carrier = &dbusPropertyDeviceAdslCarrier{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.NetworkManager.Device.Adsl',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.NetworkManager.Device.Adsl" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "Carrier" {
						obj.Carrier.Notify()
					}
				}
			} else if v.Name == "org.freedesktop.NetworkManager.Device.Adsl.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "Carrier" {
						obj.Carrier.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *DeviceAdsl) { DestroyDeviceAdsl(_obj) })
	return obj, nil
}
