/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package networkmanager

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type DeviceBluetooth struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	HwAddress      *dbusPropertyDeviceBluetoothHwAddress
	Name           *dbusPropertyDeviceBluetoothName
	BtCapabilities *dbusPropertyDeviceBluetoothBtCapabilities
}

func (obj *DeviceBluetooth) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *DeviceBluetooth) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyDeviceBluetooth(obj *DeviceBluetooth) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.HwAddress.Reset()
	obj.Name.Reset()
	obj.BtCapabilities.Reset()
}

func (obj *DeviceBluetooth) ConnectPropertiesChanged(callback func(properties map[string]dbus.Variant)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.NetworkManager.Device.Bluetooth',sender='"+obj.DestName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.Device.Bluetooth.PropertiesChanged" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*map[string]dbus.Variant)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(map[string]dbus.Variant))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyDeviceBluetoothHwAddress struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceBluetoothHwAddress) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Bluetooth.HwAddress is not writable")
}

func (this *dbusPropertyDeviceBluetoothHwAddress) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDeviceBluetoothHwAddress) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Bluetooth", "HwAddress").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:HwAddress error:", err, "at org.freedesktop.NetworkManager.Device.Bluetooth")
		return *new(string)
	}
}
func (this *dbusPropertyDeviceBluetoothHwAddress) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDeviceBluetoothName struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceBluetoothName) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Bluetooth.Name is not writable")
}

func (this *dbusPropertyDeviceBluetoothName) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDeviceBluetoothName) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Bluetooth", "Name").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:Name error:", err, "at org.freedesktop.NetworkManager.Device.Bluetooth")
		return *new(string)
	}
}
func (this *dbusPropertyDeviceBluetoothName) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDeviceBluetoothBtCapabilities struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceBluetoothBtCapabilities) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Bluetooth.BtCapabilities is not writable")
}

func (this *dbusPropertyDeviceBluetoothBtCapabilities) Get() uint32 {
	return this.GetValue().(uint32)
}
func (this *dbusPropertyDeviceBluetoothBtCapabilities) GetValue() interface{} /*uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Bluetooth", "BtCapabilities").Store(&r)
	if err == nil && r.Signature().String() == "u" {
		return r.Value().(uint32)
	} else {
		fmt.Println("dbusProperty:BtCapabilities error:", err, "at org.freedesktop.NetworkManager.Device.Bluetooth")
		return *new(uint32)
	}
}
func (this *dbusPropertyDeviceBluetoothBtCapabilities) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

func NewDeviceBluetooth(destName string, path dbus.ObjectPath) (*DeviceBluetooth, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &DeviceBluetooth{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.HwAddress = &dbusPropertyDeviceBluetoothHwAddress{&property.BaseObserver{}, core}
	obj.Name = &dbusPropertyDeviceBluetoothName{&property.BaseObserver{}, core}
	obj.BtCapabilities = &dbusPropertyDeviceBluetoothBtCapabilities{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.NetworkManager.Device.Bluetooth',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.NetworkManager.Device.Bluetooth" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "HwAddress" {
						obj.HwAddress.Notify()

					} else if key == "Name" {
						obj.Name.Notify()

					} else if key == "BtCapabilities" {
						obj.BtCapabilities.Notify()
					}
				}
			} else if v.Name == "org.freedesktop.NetworkManager.Device.Bluetooth.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "HwAddress" {
						obj.HwAddress.Notify()

					} else if key == "Name" {
						obj.Name.Notify()

					} else if key == "BtCapabilities" {
						obj.BtCapabilities.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *DeviceBluetooth) { DestroyDeviceBluetooth(_obj) })
	return obj, nil
}
