/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package networkmanager

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type DeviceWired struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	HwAddress     *dbusPropertyDeviceWiredHwAddress
	PermHwAddress *dbusPropertyDeviceWiredPermHwAddress
	Speed         *dbusPropertyDeviceWiredSpeed
	Carrier       *dbusPropertyDeviceWiredCarrier
}

func (obj *DeviceWired) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *DeviceWired) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyDeviceWired(obj *DeviceWired) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.HwAddress.Reset()
	obj.PermHwAddress.Reset()
	obj.Speed.Reset()
	obj.Carrier.Reset()
}

func (obj *DeviceWired) ConnectPropertiesChanged(callback func(properties map[string]dbus.Variant)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.NetworkManager.Device.Wired',sender='"+obj.DestName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.Device.Wired.PropertiesChanged" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*map[string]dbus.Variant)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(map[string]dbus.Variant))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyDeviceWiredHwAddress struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceWiredHwAddress) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Wired.HwAddress is not writable")
}

func (this *dbusPropertyDeviceWiredHwAddress) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDeviceWiredHwAddress) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Wired", "HwAddress").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:HwAddress error:", err, "at org.freedesktop.NetworkManager.Device.Wired")
		return *new(string)
	}
}
func (this *dbusPropertyDeviceWiredHwAddress) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDeviceWiredPermHwAddress struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceWiredPermHwAddress) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Wired.PermHwAddress is not writable")
}

func (this *dbusPropertyDeviceWiredPermHwAddress) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDeviceWiredPermHwAddress) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Wired", "PermHwAddress").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:PermHwAddress error:", err, "at org.freedesktop.NetworkManager.Device.Wired")
		return *new(string)
	}
}
func (this *dbusPropertyDeviceWiredPermHwAddress) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDeviceWiredSpeed struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceWiredSpeed) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Wired.Speed is not writable")
}

func (this *dbusPropertyDeviceWiredSpeed) Get() uint32 {
	return this.GetValue().(uint32)
}
func (this *dbusPropertyDeviceWiredSpeed) GetValue() interface{} /*uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Wired", "Speed").Store(&r)
	if err == nil && r.Signature().String() == "u" {
		return r.Value().(uint32)
	} else {
		fmt.Println("dbusProperty:Speed error:", err, "at org.freedesktop.NetworkManager.Device.Wired")
		return *new(uint32)
	}
}
func (this *dbusPropertyDeviceWiredSpeed) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

type dbusPropertyDeviceWiredCarrier struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceWiredCarrier) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Wired.Carrier is not writable")
}

func (this *dbusPropertyDeviceWiredCarrier) Get() bool {
	return this.GetValue().(bool)
}
func (this *dbusPropertyDeviceWiredCarrier) GetValue() interface{} /*bool*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Wired", "Carrier").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool)
	} else {
		fmt.Println("dbusProperty:Carrier error:", err, "at org.freedesktop.NetworkManager.Device.Wired")
		return *new(bool)
	}
}
func (this *dbusPropertyDeviceWiredCarrier) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

func NewDeviceWired(destName string, path dbus.ObjectPath) (*DeviceWired, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &DeviceWired{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.HwAddress = &dbusPropertyDeviceWiredHwAddress{&property.BaseObserver{}, core}
	obj.PermHwAddress = &dbusPropertyDeviceWiredPermHwAddress{&property.BaseObserver{}, core}
	obj.Speed = &dbusPropertyDeviceWiredSpeed{&property.BaseObserver{}, core}
	obj.Carrier = &dbusPropertyDeviceWiredCarrier{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.NetworkManager.Device.Wired',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.NetworkManager.Device.Wired" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "HwAddress" {
						obj.HwAddress.Notify()

					} else if key == "PermHwAddress" {
						obj.PermHwAddress.Notify()

					} else if key == "Speed" {
						obj.Speed.Notify()

					} else if key == "Carrier" {
						obj.Carrier.Notify()
					}
				}
			} else if v.Name == "org.freedesktop.NetworkManager.Device.Wired.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "HwAddress" {
						obj.HwAddress.Notify()

					} else if key == "PermHwAddress" {
						obj.PermHwAddress.Notify()

					} else if key == "Speed" {
						obj.Speed.Notify()

					} else if key == "Carrier" {
						obj.Carrier.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *DeviceWired) { DestroyDeviceWired(_obj) })
	return obj, nil
}
