/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package networkmanager

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type DeviceInfiniband struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	HwAddress *dbusPropertyDeviceInfinibandHwAddress
	Carrier   *dbusPropertyDeviceInfinibandCarrier
}

func (obj *DeviceInfiniband) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *DeviceInfiniband) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyDeviceInfiniband(obj *DeviceInfiniband) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.HwAddress.Reset()
	obj.Carrier.Reset()
}

func (obj *DeviceInfiniband) ConnectPropertiesChanged(callback func(properties map[string]dbus.Variant)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.NetworkManager.Device.Infiniband',sender='"+obj.DestName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.Device.Infiniband.PropertiesChanged" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*map[string]dbus.Variant)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(map[string]dbus.Variant))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyDeviceInfinibandHwAddress struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceInfinibandHwAddress) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Infiniband.HwAddress is not writable")
}

func (this *dbusPropertyDeviceInfinibandHwAddress) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDeviceInfinibandHwAddress) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Infiniband", "HwAddress").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:HwAddress error:", err, "at org.freedesktop.NetworkManager.Device.Infiniband")
		return *new(string)
	}
}
func (this *dbusPropertyDeviceInfinibandHwAddress) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDeviceInfinibandCarrier struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceInfinibandCarrier) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Infiniband.Carrier is not writable")
}

func (this *dbusPropertyDeviceInfinibandCarrier) Get() bool {
	return this.GetValue().(bool)
}
func (this *dbusPropertyDeviceInfinibandCarrier) GetValue() interface{} /*bool*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Infiniband", "Carrier").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool)
	} else {
		fmt.Println("dbusProperty:Carrier error:", err, "at org.freedesktop.NetworkManager.Device.Infiniband")
		return *new(bool)
	}
}
func (this *dbusPropertyDeviceInfinibandCarrier) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

func NewDeviceInfiniband(destName string, path dbus.ObjectPath) (*DeviceInfiniband, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &DeviceInfiniband{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.HwAddress = &dbusPropertyDeviceInfinibandHwAddress{&property.BaseObserver{}, core}
	obj.Carrier = &dbusPropertyDeviceInfinibandCarrier{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.NetworkManager.Device.Infiniband',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.NetworkManager.Device.Infiniband" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "HwAddress" {
						obj.HwAddress.Notify()

					} else if key == "Carrier" {
						obj.Carrier.Notify()
					}
				}
			} else if v.Name == "org.freedesktop.NetworkManager.Device.Infiniband.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "HwAddress" {
						obj.HwAddress.Notify()

					} else if key == "Carrier" {
						obj.Carrier.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *DeviceInfiniband) { DestroyDeviceInfiniband(_obj) })
	return obj, nil
}
