/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package networkmanager

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type DeviceModem struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	ModemCapabilities   *dbusPropertyDeviceModemModemCapabilities
	CurrentCapabilities *dbusPropertyDeviceModemCurrentCapabilities
}

func (obj *DeviceModem) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *DeviceModem) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyDeviceModem(obj *DeviceModem) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.ModemCapabilities.Reset()
	obj.CurrentCapabilities.Reset()
}

func (obj *DeviceModem) ConnectPropertiesChanged(callback func(properties map[string]dbus.Variant)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.NetworkManager.Device.Modem',sender='"+obj.DestName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.Device.Modem.PropertiesChanged" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*map[string]dbus.Variant)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(map[string]dbus.Variant))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyDeviceModemModemCapabilities struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceModemModemCapabilities) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Modem.ModemCapabilities is not writable")
}

func (this *dbusPropertyDeviceModemModemCapabilities) Get() uint32 {
	return this.GetValue().(uint32)
}
func (this *dbusPropertyDeviceModemModemCapabilities) GetValue() interface{} /*uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Modem", "ModemCapabilities").Store(&r)
	if err == nil && r.Signature().String() == "u" {
		return r.Value().(uint32)
	} else {
		fmt.Println("dbusProperty:ModemCapabilities error:", err, "at org.freedesktop.NetworkManager.Device.Modem")
		return *new(uint32)
	}
}
func (this *dbusPropertyDeviceModemModemCapabilities) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

type dbusPropertyDeviceModemCurrentCapabilities struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceModemCurrentCapabilities) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Modem.CurrentCapabilities is not writable")
}

func (this *dbusPropertyDeviceModemCurrentCapabilities) Get() uint32 {
	return this.GetValue().(uint32)
}
func (this *dbusPropertyDeviceModemCurrentCapabilities) GetValue() interface{} /*uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Modem", "CurrentCapabilities").Store(&r)
	if err == nil && r.Signature().String() == "u" {
		return r.Value().(uint32)
	} else {
		fmt.Println("dbusProperty:CurrentCapabilities error:", err, "at org.freedesktop.NetworkManager.Device.Modem")
		return *new(uint32)
	}
}
func (this *dbusPropertyDeviceModemCurrentCapabilities) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

func NewDeviceModem(destName string, path dbus.ObjectPath) (*DeviceModem, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &DeviceModem{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.ModemCapabilities = &dbusPropertyDeviceModemModemCapabilities{&property.BaseObserver{}, core}
	obj.CurrentCapabilities = &dbusPropertyDeviceModemCurrentCapabilities{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.NetworkManager.Device.Modem',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.NetworkManager.Device.Modem" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "ModemCapabilities" {
						obj.ModemCapabilities.Notify()

					} else if key == "CurrentCapabilities" {
						obj.CurrentCapabilities.Notify()
					}
				}
			} else if v.Name == "org.freedesktop.NetworkManager.Device.Modem.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "ModemCapabilities" {
						obj.ModemCapabilities.Notify()

					} else if key == "CurrentCapabilities" {
						obj.CurrentCapabilities.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *DeviceModem) { DestroyDeviceModem(_obj) })
	return obj, nil
}
