/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package networkmanager

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type DeviceVlan struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	HwAddress *dbusPropertyDeviceVlanHwAddress
	Carrier   *dbusPropertyDeviceVlanCarrier
	VlanId    *dbusPropertyDeviceVlanVlanId
}

func (obj *DeviceVlan) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *DeviceVlan) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyDeviceVlan(obj *DeviceVlan) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.HwAddress.Reset()
	obj.Carrier.Reset()
	obj.VlanId.Reset()
}

func (obj *DeviceVlan) ConnectPropertiesChanged(callback func(properties map[string]dbus.Variant)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.NetworkManager.Device.Vlan',sender='"+obj.DestName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.Device.Vlan.PropertiesChanged" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*map[string]dbus.Variant)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(map[string]dbus.Variant))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyDeviceVlanHwAddress struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceVlanHwAddress) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Vlan.HwAddress is not writable")
}

func (this *dbusPropertyDeviceVlanHwAddress) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDeviceVlanHwAddress) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Vlan", "HwAddress").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:HwAddress error:", err, "at org.freedesktop.NetworkManager.Device.Vlan")
		return *new(string)
	}
}
func (this *dbusPropertyDeviceVlanHwAddress) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDeviceVlanCarrier struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceVlanCarrier) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Vlan.Carrier is not writable")
}

func (this *dbusPropertyDeviceVlanCarrier) Get() bool {
	return this.GetValue().(bool)
}
func (this *dbusPropertyDeviceVlanCarrier) GetValue() interface{} /*bool*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Vlan", "Carrier").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool)
	} else {
		fmt.Println("dbusProperty:Carrier error:", err, "at org.freedesktop.NetworkManager.Device.Vlan")
		return *new(bool)
	}
}
func (this *dbusPropertyDeviceVlanCarrier) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

type dbusPropertyDeviceVlanVlanId struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceVlanVlanId) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Vlan.VlanId is not writable")
}

func (this *dbusPropertyDeviceVlanVlanId) Get() uint32 {
	return this.GetValue().(uint32)
}
func (this *dbusPropertyDeviceVlanVlanId) GetValue() interface{} /*uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Vlan", "VlanId").Store(&r)
	if err == nil && r.Signature().String() == "u" {
		return r.Value().(uint32)
	} else {
		fmt.Println("dbusProperty:VlanId error:", err, "at org.freedesktop.NetworkManager.Device.Vlan")
		return *new(uint32)
	}
}
func (this *dbusPropertyDeviceVlanVlanId) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

func NewDeviceVlan(destName string, path dbus.ObjectPath) (*DeviceVlan, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &DeviceVlan{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.HwAddress = &dbusPropertyDeviceVlanHwAddress{&property.BaseObserver{}, core}
	obj.Carrier = &dbusPropertyDeviceVlanCarrier{&property.BaseObserver{}, core}
	obj.VlanId = &dbusPropertyDeviceVlanVlanId{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.NetworkManager.Device.Vlan',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.NetworkManager.Device.Vlan" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "HwAddress" {
						obj.HwAddress.Notify()

					} else if key == "Carrier" {
						obj.Carrier.Notify()

					} else if key == "VlanId" {
						obj.VlanId.Notify()
					}
				}
			} else if v.Name == "org.freedesktop.NetworkManager.Device.Vlan.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "HwAddress" {
						obj.HwAddress.Notify()

					} else if key == "Carrier" {
						obj.Carrier.Notify()

					} else if key == "VlanId" {
						obj.VlanId.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *DeviceVlan) { DestroyDeviceVlan(_obj) })
	return obj, nil
}
