/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package networkmanager

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type DeviceWireless struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	HwAddress            *dbusPropertyDeviceWirelessHwAddress
	PermHwAddress        *dbusPropertyDeviceWirelessPermHwAddress
	Mode                 *dbusPropertyDeviceWirelessMode
	Bitrate              *dbusPropertyDeviceWirelessBitrate
	ActiveAccessPoint    *dbusPropertyDeviceWirelessActiveAccessPoint
	WirelessCapabilities *dbusPropertyDeviceWirelessWirelessCapabilities
}

func (obj *DeviceWireless) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *DeviceWireless) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyDeviceWireless(obj *DeviceWireless) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.HwAddress.Reset()
	obj.PermHwAddress.Reset()
	obj.Mode.Reset()
	obj.Bitrate.Reset()
	obj.ActiveAccessPoint.Reset()
	obj.WirelessCapabilities.Reset()
}

func (obj *DeviceWireless) GetAccessPoints() (access_points []dbus.ObjectPath, _err error) {
	_err = obj.core.Call("org.freedesktop.NetworkManager.Device.Wireless.GetAccessPoints", 0).Store(&access_points)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *DeviceWireless) RequestScan(options map[string]dbus.Variant) (_err error) {
	_err = obj.core.Call("org.freedesktop.NetworkManager.Device.Wireless.RequestScan", 0, options).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *DeviceWireless) ConnectPropertiesChanged(callback func(properties map[string]dbus.Variant)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.NetworkManager.Device.Wireless',sender='"+obj.DestName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.Device.Wireless.PropertiesChanged" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*map[string]dbus.Variant)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(map[string]dbus.Variant))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

func (obj *DeviceWireless) ConnectAccessPointAdded(callback func(access_point dbus.ObjectPath)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.NetworkManager.Device.Wireless',sender='"+obj.DestName+"',member='AccessPointAdded'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.Device.Wireless.AccessPointAdded" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(dbus.ObjectPath))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

func (obj *DeviceWireless) ConnectAccessPointRemoved(callback func(access_point dbus.ObjectPath)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.NetworkManager.Device.Wireless',sender='"+obj.DestName+"',member='AccessPointRemoved'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.Device.Wireless.AccessPointRemoved" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(dbus.ObjectPath))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyDeviceWirelessHwAddress struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceWirelessHwAddress) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Wireless.HwAddress is not writable")
}

func (this *dbusPropertyDeviceWirelessHwAddress) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDeviceWirelessHwAddress) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Wireless", "HwAddress").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:HwAddress error:", err, "at org.freedesktop.NetworkManager.Device.Wireless")
		return *new(string)
	}
}
func (this *dbusPropertyDeviceWirelessHwAddress) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDeviceWirelessPermHwAddress struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceWirelessPermHwAddress) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Wireless.PermHwAddress is not writable")
}

func (this *dbusPropertyDeviceWirelessPermHwAddress) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDeviceWirelessPermHwAddress) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Wireless", "PermHwAddress").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:PermHwAddress error:", err, "at org.freedesktop.NetworkManager.Device.Wireless")
		return *new(string)
	}
}
func (this *dbusPropertyDeviceWirelessPermHwAddress) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDeviceWirelessMode struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceWirelessMode) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Wireless.Mode is not writable")
}

func (this *dbusPropertyDeviceWirelessMode) Get() uint32 {
	return this.GetValue().(uint32)
}
func (this *dbusPropertyDeviceWirelessMode) GetValue() interface{} /*uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Wireless", "Mode").Store(&r)
	if err == nil && r.Signature().String() == "u" {
		return r.Value().(uint32)
	} else {
		fmt.Println("dbusProperty:Mode error:", err, "at org.freedesktop.NetworkManager.Device.Wireless")
		return *new(uint32)
	}
}
func (this *dbusPropertyDeviceWirelessMode) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

type dbusPropertyDeviceWirelessBitrate struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceWirelessBitrate) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Wireless.Bitrate is not writable")
}

func (this *dbusPropertyDeviceWirelessBitrate) Get() uint32 {
	return this.GetValue().(uint32)
}
func (this *dbusPropertyDeviceWirelessBitrate) GetValue() interface{} /*uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Wireless", "Bitrate").Store(&r)
	if err == nil && r.Signature().String() == "u" {
		return r.Value().(uint32)
	} else {
		fmt.Println("dbusProperty:Bitrate error:", err, "at org.freedesktop.NetworkManager.Device.Wireless")
		return *new(uint32)
	}
}
func (this *dbusPropertyDeviceWirelessBitrate) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

type dbusPropertyDeviceWirelessActiveAccessPoint struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceWirelessActiveAccessPoint) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Wireless.ActiveAccessPoint is not writable")
}

func (this *dbusPropertyDeviceWirelessActiveAccessPoint) Get() dbus.ObjectPath {
	return this.GetValue().(dbus.ObjectPath)
}
func (this *dbusPropertyDeviceWirelessActiveAccessPoint) GetValue() interface{} /*dbus.ObjectPath*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Wireless", "ActiveAccessPoint").Store(&r)
	if err == nil && r.Signature().String() == "o" {
		return r.Value().(dbus.ObjectPath)
	} else {
		fmt.Println("dbusProperty:ActiveAccessPoint error:", err, "at org.freedesktop.NetworkManager.Device.Wireless")
		return *new(dbus.ObjectPath)
	}
}
func (this *dbusPropertyDeviceWirelessActiveAccessPoint) GetType() reflect.Type {
	return reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem()
}

type dbusPropertyDeviceWirelessWirelessCapabilities struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceWirelessWirelessCapabilities) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Wireless.WirelessCapabilities is not writable")
}

func (this *dbusPropertyDeviceWirelessWirelessCapabilities) Get() uint32 {
	return this.GetValue().(uint32)
}
func (this *dbusPropertyDeviceWirelessWirelessCapabilities) GetValue() interface{} /*uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device.Wireless", "WirelessCapabilities").Store(&r)
	if err == nil && r.Signature().String() == "u" {
		return r.Value().(uint32)
	} else {
		fmt.Println("dbusProperty:WirelessCapabilities error:", err, "at org.freedesktop.NetworkManager.Device.Wireless")
		return *new(uint32)
	}
}
func (this *dbusPropertyDeviceWirelessWirelessCapabilities) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

func NewDeviceWireless(destName string, path dbus.ObjectPath) (*DeviceWireless, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &DeviceWireless{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.HwAddress = &dbusPropertyDeviceWirelessHwAddress{&property.BaseObserver{}, core}
	obj.PermHwAddress = &dbusPropertyDeviceWirelessPermHwAddress{&property.BaseObserver{}, core}
	obj.Mode = &dbusPropertyDeviceWirelessMode{&property.BaseObserver{}, core}
	obj.Bitrate = &dbusPropertyDeviceWirelessBitrate{&property.BaseObserver{}, core}
	obj.ActiveAccessPoint = &dbusPropertyDeviceWirelessActiveAccessPoint{&property.BaseObserver{}, core}
	obj.WirelessCapabilities = &dbusPropertyDeviceWirelessWirelessCapabilities{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.NetworkManager.Device.Wireless',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.NetworkManager.Device.Wireless" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "HwAddress" {
						obj.HwAddress.Notify()

					} else if key == "PermHwAddress" {
						obj.PermHwAddress.Notify()

					} else if key == "Mode" {
						obj.Mode.Notify()

					} else if key == "Bitrate" {
						obj.Bitrate.Notify()

					} else if key == "ActiveAccessPoint" {
						obj.ActiveAccessPoint.Notify()

					} else if key == "WirelessCapabilities" {
						obj.WirelessCapabilities.Notify()
					}
				}
			} else if v.Name == "org.freedesktop.NetworkManager.Device.Wireless.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "HwAddress" {
						obj.HwAddress.Notify()

					} else if key == "PermHwAddress" {
						obj.PermHwAddress.Notify()

					} else if key == "Mode" {
						obj.Mode.Notify()

					} else if key == "Bitrate" {
						obj.Bitrate.Notify()

					} else if key == "ActiveAccessPoint" {
						obj.ActiveAccessPoint.Notify()

					} else if key == "WirelessCapabilities" {
						obj.WirelessCapabilities.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *DeviceWireless) { DestroyDeviceWireless(_obj) })
	return obj, nil
}
