/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package networkmanager

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type Device struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	Udi                  *dbusPropertyDeviceUdi
	Interface            *dbusPropertyDeviceInterface
	IpInterface          *dbusPropertyDeviceIpInterface
	Driver               *dbusPropertyDeviceDriver
	DriverVersion        *dbusPropertyDeviceDriverVersion
	FirmwareVersion      *dbusPropertyDeviceFirmwareVersion
	Capabilities         *dbusPropertyDeviceCapabilities
	Ip4Address           *dbusPropertyDeviceIp4Address
	State                *dbusPropertyDeviceState
	StateReason          *dbusPropertyDeviceStateReason
	ActiveConnection     *dbusPropertyDeviceActiveConnection
	Ip4Config            *dbusPropertyDeviceIp4Config
	Dhcp4Config          *dbusPropertyDeviceDhcp4Config
	Ip6Config            *dbusPropertyDeviceIp6Config
	Dhcp6Config          *dbusPropertyDeviceDhcp6Config
	Managed              *dbusPropertyDeviceManaged
	Autoconnect          *dbusPropertyDeviceAutoconnect
	FirmwareMissing      *dbusPropertyDeviceFirmwareMissing
	DeviceType           *dbusPropertyDeviceDeviceType
	AvailableConnections *dbusPropertyDeviceAvailableConnections
}

func (obj *Device) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *Device) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyDevice(obj *Device) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.Udi.Reset()
	obj.Interface.Reset()
	obj.IpInterface.Reset()
	obj.Driver.Reset()
	obj.DriverVersion.Reset()
	obj.FirmwareVersion.Reset()
	obj.Capabilities.Reset()
	obj.Ip4Address.Reset()
	obj.State.Reset()
	obj.StateReason.Reset()
	obj.ActiveConnection.Reset()
	obj.Ip4Config.Reset()
	obj.Dhcp4Config.Reset()
	obj.Ip6Config.Reset()
	obj.Dhcp6Config.Reset()
	obj.Managed.Reset()
	obj.Autoconnect.Reset()
	obj.FirmwareMissing.Reset()
	obj.DeviceType.Reset()
	obj.AvailableConnections.Reset()
}

func (obj *Device) Disconnect() (_err error) {
	_err = obj.core.Call("org.freedesktop.NetworkManager.Device.Disconnect", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Device) ConnectStateChanged(callback func(new_state uint32, old_state uint32, reason uint32)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.NetworkManager.Device',sender='"+obj.DestName+"',member='StateChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.Device.StateChanged" || 3 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*uint32)(nil)).Elem() {
				continue
			}
			if reflect.TypeOf(v.Body[1]) != reflect.TypeOf((*uint32)(nil)).Elem() {
				continue
			}
			if reflect.TypeOf(v.Body[2]) != reflect.TypeOf((*uint32)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(uint32), v.Body[1].(uint32), v.Body[2].(uint32))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyDeviceUdi struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceUdi) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Udi is not writable")
}

func (this *dbusPropertyDeviceUdi) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDeviceUdi) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "Udi").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:Udi error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(string)
	}
}
func (this *dbusPropertyDeviceUdi) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDeviceInterface struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceInterface) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Interface is not writable")
}

func (this *dbusPropertyDeviceInterface) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDeviceInterface) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "Interface").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:Interface error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(string)
	}
}
func (this *dbusPropertyDeviceInterface) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDeviceIpInterface struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceIpInterface) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.IpInterface is not writable")
}

func (this *dbusPropertyDeviceIpInterface) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDeviceIpInterface) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "IpInterface").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:IpInterface error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(string)
	}
}
func (this *dbusPropertyDeviceIpInterface) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDeviceDriver struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceDriver) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Driver is not writable")
}

func (this *dbusPropertyDeviceDriver) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDeviceDriver) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "Driver").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:Driver error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(string)
	}
}
func (this *dbusPropertyDeviceDriver) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDeviceDriverVersion struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceDriverVersion) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.DriverVersion is not writable")
}

func (this *dbusPropertyDeviceDriverVersion) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDeviceDriverVersion) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "DriverVersion").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:DriverVersion error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(string)
	}
}
func (this *dbusPropertyDeviceDriverVersion) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDeviceFirmwareVersion struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceFirmwareVersion) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.FirmwareVersion is not writable")
}

func (this *dbusPropertyDeviceFirmwareVersion) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyDeviceFirmwareVersion) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "FirmwareVersion").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:FirmwareVersion error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(string)
	}
}
func (this *dbusPropertyDeviceFirmwareVersion) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyDeviceCapabilities struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceCapabilities) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Capabilities is not writable")
}

func (this *dbusPropertyDeviceCapabilities) Get() uint32 {
	return this.GetValue().(uint32)
}
func (this *dbusPropertyDeviceCapabilities) GetValue() interface{} /*uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "Capabilities").Store(&r)
	if err == nil && r.Signature().String() == "u" {
		return r.Value().(uint32)
	} else {
		fmt.Println("dbusProperty:Capabilities error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(uint32)
	}
}
func (this *dbusPropertyDeviceCapabilities) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

type dbusPropertyDeviceIp4Address struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceIp4Address) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Ip4Address is not writable")
}

func (this *dbusPropertyDeviceIp4Address) Get() uint32 {
	return this.GetValue().(uint32)
}
func (this *dbusPropertyDeviceIp4Address) GetValue() interface{} /*uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "Ip4Address").Store(&r)
	if err == nil && r.Signature().String() == "u" {
		return r.Value().(uint32)
	} else {
		fmt.Println("dbusProperty:Ip4Address error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(uint32)
	}
}
func (this *dbusPropertyDeviceIp4Address) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

type dbusPropertyDeviceState struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceState) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.State is not writable")
}

func (this *dbusPropertyDeviceState) Get() uint32 {
	return this.GetValue().(uint32)
}
func (this *dbusPropertyDeviceState) GetValue() interface{} /*uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "State").Store(&r)
	if err == nil && r.Signature().String() == "u" {
		return r.Value().(uint32)
	} else {
		fmt.Println("dbusProperty:State error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(uint32)
	}
}
func (this *dbusPropertyDeviceState) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

type dbusPropertyDeviceStateReason struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceStateReason) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.StateReason is not writable")
}

func (this *dbusPropertyDeviceStateReason) Get() []interface{} {
	return this.GetValue().([]interface{})
}
func (this *dbusPropertyDeviceStateReason) GetValue() interface{} /*[]interface {}*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "StateReason").Store(&r)
	if err == nil && r.Signature().String() == "(uu)" {
		return r.Value().([]interface{})
	} else {
		fmt.Println("dbusProperty:StateReason error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new([]interface{})
	}
}
func (this *dbusPropertyDeviceStateReason) GetType() reflect.Type {
	return reflect.TypeOf((*[]interface{})(nil)).Elem()
}

type dbusPropertyDeviceActiveConnection struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceActiveConnection) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.ActiveConnection is not writable")
}

func (this *dbusPropertyDeviceActiveConnection) Get() dbus.ObjectPath {
	return this.GetValue().(dbus.ObjectPath)
}
func (this *dbusPropertyDeviceActiveConnection) GetValue() interface{} /*dbus.ObjectPath*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "ActiveConnection").Store(&r)
	if err == nil && r.Signature().String() == "o" {
		return r.Value().(dbus.ObjectPath)
	} else {
		fmt.Println("dbusProperty:ActiveConnection error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(dbus.ObjectPath)
	}
}
func (this *dbusPropertyDeviceActiveConnection) GetType() reflect.Type {
	return reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem()
}

type dbusPropertyDeviceIp4Config struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceIp4Config) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Ip4Config is not writable")
}

func (this *dbusPropertyDeviceIp4Config) Get() dbus.ObjectPath {
	return this.GetValue().(dbus.ObjectPath)
}
func (this *dbusPropertyDeviceIp4Config) GetValue() interface{} /*dbus.ObjectPath*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "Ip4Config").Store(&r)
	if err == nil && r.Signature().String() == "o" {
		return r.Value().(dbus.ObjectPath)
	} else {
		fmt.Println("dbusProperty:Ip4Config error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(dbus.ObjectPath)
	}
}
func (this *dbusPropertyDeviceIp4Config) GetType() reflect.Type {
	return reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem()
}

type dbusPropertyDeviceDhcp4Config struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceDhcp4Config) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Dhcp4Config is not writable")
}

func (this *dbusPropertyDeviceDhcp4Config) Get() dbus.ObjectPath {
	return this.GetValue().(dbus.ObjectPath)
}
func (this *dbusPropertyDeviceDhcp4Config) GetValue() interface{} /*dbus.ObjectPath*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "Dhcp4Config").Store(&r)
	if err == nil && r.Signature().String() == "o" {
		return r.Value().(dbus.ObjectPath)
	} else {
		fmt.Println("dbusProperty:Dhcp4Config error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(dbus.ObjectPath)
	}
}
func (this *dbusPropertyDeviceDhcp4Config) GetType() reflect.Type {
	return reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem()
}

type dbusPropertyDeviceIp6Config struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceIp6Config) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Ip6Config is not writable")
}

func (this *dbusPropertyDeviceIp6Config) Get() dbus.ObjectPath {
	return this.GetValue().(dbus.ObjectPath)
}
func (this *dbusPropertyDeviceIp6Config) GetValue() interface{} /*dbus.ObjectPath*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "Ip6Config").Store(&r)
	if err == nil && r.Signature().String() == "o" {
		return r.Value().(dbus.ObjectPath)
	} else {
		fmt.Println("dbusProperty:Ip6Config error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(dbus.ObjectPath)
	}
}
func (this *dbusPropertyDeviceIp6Config) GetType() reflect.Type {
	return reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem()
}

type dbusPropertyDeviceDhcp6Config struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceDhcp6Config) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Dhcp6Config is not writable")
}

func (this *dbusPropertyDeviceDhcp6Config) Get() dbus.ObjectPath {
	return this.GetValue().(dbus.ObjectPath)
}
func (this *dbusPropertyDeviceDhcp6Config) GetValue() interface{} /*dbus.ObjectPath*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "Dhcp6Config").Store(&r)
	if err == nil && r.Signature().String() == "o" {
		return r.Value().(dbus.ObjectPath)
	} else {
		fmt.Println("dbusProperty:Dhcp6Config error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(dbus.ObjectPath)
	}
}
func (this *dbusPropertyDeviceDhcp6Config) GetType() reflect.Type {
	return reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem()
}

type dbusPropertyDeviceManaged struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceManaged) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.Managed is not writable")
}

func (this *dbusPropertyDeviceManaged) Get() bool {
	return this.GetValue().(bool)
}
func (this *dbusPropertyDeviceManaged) GetValue() interface{} /*bool*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "Managed").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool)
	} else {
		fmt.Println("dbusProperty:Managed error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(bool)
	}
}
func (this *dbusPropertyDeviceManaged) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

type dbusPropertyDeviceAutoconnect struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceAutoconnect) SetValue(v interface{} /*bool*/) {
	if reflect.TypeOf(v) == reflect.TypeOf((*bool)(nil)).Elem() {
		this.core.Call("org.freedesktop.DBus.Properties.Set", 0, "org.freedesktop.NetworkManager.Device", "Autoconnect", dbus.MakeVariant(v))
	} else {
		fmt.Println("The property Autoconnect of org.freedesktop.NetworkManager.Device is an bool but Set with an ", reflect.TypeOf(v))
	}
}
func (this *dbusPropertyDeviceAutoconnect) Set(v bool) {
	this.SetValue(v)
}

func (this *dbusPropertyDeviceAutoconnect) Get() bool {
	return this.GetValue().(bool)
}
func (this *dbusPropertyDeviceAutoconnect) GetValue() interface{} /*bool*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "Autoconnect").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool)
	} else {
		fmt.Println("dbusProperty:Autoconnect error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(bool)
	}
}
func (this *dbusPropertyDeviceAutoconnect) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

type dbusPropertyDeviceFirmwareMissing struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceFirmwareMissing) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.FirmwareMissing is not writable")
}

func (this *dbusPropertyDeviceFirmwareMissing) Get() bool {
	return this.GetValue().(bool)
}
func (this *dbusPropertyDeviceFirmwareMissing) GetValue() interface{} /*bool*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "FirmwareMissing").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool)
	} else {
		fmt.Println("dbusProperty:FirmwareMissing error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(bool)
	}
}
func (this *dbusPropertyDeviceFirmwareMissing) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

type dbusPropertyDeviceDeviceType struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceDeviceType) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.DeviceType is not writable")
}

func (this *dbusPropertyDeviceDeviceType) Get() uint32 {
	return this.GetValue().(uint32)
}
func (this *dbusPropertyDeviceDeviceType) GetValue() interface{} /*uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "DeviceType").Store(&r)
	if err == nil && r.Signature().String() == "u" {
		return r.Value().(uint32)
	} else {
		fmt.Println("dbusProperty:DeviceType error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new(uint32)
	}
}
func (this *dbusPropertyDeviceDeviceType) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

type dbusPropertyDeviceAvailableConnections struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyDeviceAvailableConnections) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Device.AvailableConnections is not writable")
}

func (this *dbusPropertyDeviceAvailableConnections) Get() []dbus.ObjectPath {
	return this.GetValue().([]dbus.ObjectPath)
}
func (this *dbusPropertyDeviceAvailableConnections) GetValue() interface{} /*[]dbus.ObjectPath*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Device", "AvailableConnections").Store(&r)
	if err == nil && r.Signature().String() == "ao" {
		return r.Value().([]dbus.ObjectPath)
	} else {
		fmt.Println("dbusProperty:AvailableConnections error:", err, "at org.freedesktop.NetworkManager.Device")
		return *new([]dbus.ObjectPath)
	}
}
func (this *dbusPropertyDeviceAvailableConnections) GetType() reflect.Type {
	return reflect.TypeOf((*[]dbus.ObjectPath)(nil)).Elem()
}

func NewDevice(destName string, path dbus.ObjectPath) (*Device, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &Device{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.Udi = &dbusPropertyDeviceUdi{&property.BaseObserver{}, core}
	obj.Interface = &dbusPropertyDeviceInterface{&property.BaseObserver{}, core}
	obj.IpInterface = &dbusPropertyDeviceIpInterface{&property.BaseObserver{}, core}
	obj.Driver = &dbusPropertyDeviceDriver{&property.BaseObserver{}, core}
	obj.DriverVersion = &dbusPropertyDeviceDriverVersion{&property.BaseObserver{}, core}
	obj.FirmwareVersion = &dbusPropertyDeviceFirmwareVersion{&property.BaseObserver{}, core}
	obj.Capabilities = &dbusPropertyDeviceCapabilities{&property.BaseObserver{}, core}
	obj.Ip4Address = &dbusPropertyDeviceIp4Address{&property.BaseObserver{}, core}
	obj.State = &dbusPropertyDeviceState{&property.BaseObserver{}, core}
	obj.StateReason = &dbusPropertyDeviceStateReason{&property.BaseObserver{}, core}
	obj.ActiveConnection = &dbusPropertyDeviceActiveConnection{&property.BaseObserver{}, core}
	obj.Ip4Config = &dbusPropertyDeviceIp4Config{&property.BaseObserver{}, core}
	obj.Dhcp4Config = &dbusPropertyDeviceDhcp4Config{&property.BaseObserver{}, core}
	obj.Ip6Config = &dbusPropertyDeviceIp6Config{&property.BaseObserver{}, core}
	obj.Dhcp6Config = &dbusPropertyDeviceDhcp6Config{&property.BaseObserver{}, core}
	obj.Managed = &dbusPropertyDeviceManaged{&property.BaseObserver{}, core}
	obj.Autoconnect = &dbusPropertyDeviceAutoconnect{&property.BaseObserver{}, core}
	obj.FirmwareMissing = &dbusPropertyDeviceFirmwareMissing{&property.BaseObserver{}, core}
	obj.DeviceType = &dbusPropertyDeviceDeviceType{&property.BaseObserver{}, core}
	obj.AvailableConnections = &dbusPropertyDeviceAvailableConnections{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.NetworkManager.Device',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.NetworkManager.Device" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "Udi" {
						obj.Udi.Notify()

					} else if key == "Interface" {
						obj.Interface.Notify()

					} else if key == "IpInterface" {
						obj.IpInterface.Notify()

					} else if key == "Driver" {
						obj.Driver.Notify()

					} else if key == "DriverVersion" {
						obj.DriverVersion.Notify()

					} else if key == "FirmwareVersion" {
						obj.FirmwareVersion.Notify()

					} else if key == "Capabilities" {
						obj.Capabilities.Notify()

					} else if key == "Ip4Address" {
						obj.Ip4Address.Notify()

					} else if key == "State" {
						obj.State.Notify()

					} else if key == "StateReason" {
						obj.StateReason.Notify()

					} else if key == "ActiveConnection" {
						obj.ActiveConnection.Notify()

					} else if key == "Ip4Config" {
						obj.Ip4Config.Notify()

					} else if key == "Dhcp4Config" {
						obj.Dhcp4Config.Notify()

					} else if key == "Ip6Config" {
						obj.Ip6Config.Notify()

					} else if key == "Dhcp6Config" {
						obj.Dhcp6Config.Notify()

					} else if key == "Managed" {
						obj.Managed.Notify()

					} else if key == "Autoconnect" {
						obj.Autoconnect.Notify()

					} else if key == "FirmwareMissing" {
						obj.FirmwareMissing.Notify()

					} else if key == "DeviceType" {
						obj.DeviceType.Notify()

					} else if key == "AvailableConnections" {
						obj.AvailableConnections.Notify()
					}
				}
			} else if v.Name == "org.freedesktop.NetworkManager.Device.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "Udi" {
						obj.Udi.Notify()

					} else if key == "Interface" {
						obj.Interface.Notify()

					} else if key == "IpInterface" {
						obj.IpInterface.Notify()

					} else if key == "Driver" {
						obj.Driver.Notify()

					} else if key == "DriverVersion" {
						obj.DriverVersion.Notify()

					} else if key == "FirmwareVersion" {
						obj.FirmwareVersion.Notify()

					} else if key == "Capabilities" {
						obj.Capabilities.Notify()

					} else if key == "Ip4Address" {
						obj.Ip4Address.Notify()

					} else if key == "State" {
						obj.State.Notify()

					} else if key == "StateReason" {
						obj.StateReason.Notify()

					} else if key == "ActiveConnection" {
						obj.ActiveConnection.Notify()

					} else if key == "Ip4Config" {
						obj.Ip4Config.Notify()

					} else if key == "Dhcp4Config" {
						obj.Dhcp4Config.Notify()

					} else if key == "Ip6Config" {
						obj.Ip6Config.Notify()

					} else if key == "Dhcp6Config" {
						obj.Dhcp6Config.Notify()

					} else if key == "Managed" {
						obj.Managed.Notify()

					} else if key == "Autoconnect" {
						obj.Autoconnect.Notify()

					} else if key == "FirmwareMissing" {
						obj.FirmwareMissing.Notify()

					} else if key == "DeviceType" {
						obj.DeviceType.Notify()

					} else if key == "AvailableConnections" {
						obj.AvailableConnections.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *Device) { DestroyDevice(_obj) })
	return obj, nil
}
