/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package networkmanager

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type IP6Config struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	Addresses   *dbusPropertyIP6ConfigAddresses
	Nameservers *dbusPropertyIP6ConfigNameservers
	Domains     *dbusPropertyIP6ConfigDomains
	Routes      *dbusPropertyIP6ConfigRoutes
}

func (obj *IP6Config) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *IP6Config) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyIP6Config(obj *IP6Config) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.Addresses.Reset()
	obj.Nameservers.Reset()
	obj.Domains.Reset()
	obj.Routes.Reset()
}

type dbusPropertyIP6ConfigAddresses struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyIP6ConfigAddresses) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.IP6Config.Addresses is not writable")
}

func (this *dbusPropertyIP6ConfigAddresses) Get() [][]interface{} {
	return this.GetValue().([][]interface{})
}
func (this *dbusPropertyIP6ConfigAddresses) GetValue() interface{} /*[][]interface {}*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.IP6Config", "Addresses").Store(&r)
	if err == nil && r.Signature().String() == "a(ayuay)" {
		return r.Value().([][]interface{})
	} else {
		fmt.Println("dbusProperty:Addresses error:", err, "at org.freedesktop.NetworkManager.IP6Config")
		return *new([][]interface{})
	}
}
func (this *dbusPropertyIP6ConfigAddresses) GetType() reflect.Type {
	return reflect.TypeOf((*[][]interface{})(nil)).Elem()
}

type dbusPropertyIP6ConfigNameservers struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyIP6ConfigNameservers) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.IP6Config.Nameservers is not writable")
}

func (this *dbusPropertyIP6ConfigNameservers) Get() [][]uint8 {
	return this.GetValue().([][]uint8)
}
func (this *dbusPropertyIP6ConfigNameservers) GetValue() interface{} /*[][]uint8*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.IP6Config", "Nameservers").Store(&r)
	if err == nil && r.Signature().String() == "aay" {
		return r.Value().([][]uint8)
	} else {
		fmt.Println("dbusProperty:Nameservers error:", err, "at org.freedesktop.NetworkManager.IP6Config")
		return *new([][]uint8)
	}
}
func (this *dbusPropertyIP6ConfigNameservers) GetType() reflect.Type {
	return reflect.TypeOf((*[][]uint8)(nil)).Elem()
}

type dbusPropertyIP6ConfigDomains struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyIP6ConfigDomains) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.IP6Config.Domains is not writable")
}

func (this *dbusPropertyIP6ConfigDomains) Get() []string {
	return this.GetValue().([]string)
}
func (this *dbusPropertyIP6ConfigDomains) GetValue() interface{} /*[]string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.IP6Config", "Domains").Store(&r)
	if err == nil && r.Signature().String() == "as" {
		return r.Value().([]string)
	} else {
		fmt.Println("dbusProperty:Domains error:", err, "at org.freedesktop.NetworkManager.IP6Config")
		return *new([]string)
	}
}
func (this *dbusPropertyIP6ConfigDomains) GetType() reflect.Type {
	return reflect.TypeOf((*[]string)(nil)).Elem()
}

type dbusPropertyIP6ConfigRoutes struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyIP6ConfigRoutes) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.IP6Config.Routes is not writable")
}

func (this *dbusPropertyIP6ConfigRoutes) Get() [][]interface{} {
	return this.GetValue().([][]interface{})
}
func (this *dbusPropertyIP6ConfigRoutes) GetValue() interface{} /*[][]interface {}*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.IP6Config", "Routes").Store(&r)
	if err == nil && r.Signature().String() == "a(ayuayu)" {
		return r.Value().([][]interface{})
	} else {
		fmt.Println("dbusProperty:Routes error:", err, "at org.freedesktop.NetworkManager.IP6Config")
		return *new([][]interface{})
	}
}
func (this *dbusPropertyIP6ConfigRoutes) GetType() reflect.Type {
	return reflect.TypeOf((*[][]interface{})(nil)).Elem()
}

func NewIP6Config(destName string, path dbus.ObjectPath) (*IP6Config, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &IP6Config{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.Addresses = &dbusPropertyIP6ConfigAddresses{&property.BaseObserver{}, core}
	obj.Nameservers = &dbusPropertyIP6ConfigNameservers{&property.BaseObserver{}, core}
	obj.Domains = &dbusPropertyIP6ConfigDomains{&property.BaseObserver{}, core}
	obj.Routes = &dbusPropertyIP6ConfigRoutes{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.NetworkManager.IP6Config',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.NetworkManager.IP6Config" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "Addresses" {
						obj.Addresses.Notify()

					} else if key == "Nameservers" {
						obj.Nameservers.Notify()

					} else if key == "Domains" {
						obj.Domains.Notify()

					} else if key == "Routes" {
						obj.Routes.Notify()
					}
				}
			} else if v.Name == "org.freedesktop.NetworkManager.IP6Config.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "Addresses" {
						obj.Addresses.Notify()

					} else if key == "Nameservers" {
						obj.Nameservers.Notify()

					} else if key == "Domains" {
						obj.Domains.Notify()

					} else if key == "Routes" {
						obj.Routes.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *IP6Config) { DestroyIP6Config(_obj) })
	return obj, nil
}
