/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package networkmanager

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type SettingsConnection struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex
}

func (obj *SettingsConnection) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *SettingsConnection) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroySettingsConnection(obj *SettingsConnection) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

}

func (obj *SettingsConnection) Update(properties map[string]map[string]dbus.Variant) (_err error) {
	_err = obj.core.Call("org.freedesktop.NetworkManager.Settings.Connection.Update", 0, properties).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *SettingsConnection) Delete() (_err error) {
	_err = obj.core.Call("org.freedesktop.NetworkManager.Settings.Connection.Delete", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *SettingsConnection) GetSettings() (settings map[string]map[string]dbus.Variant, _err error) {
	_err = obj.core.Call("org.freedesktop.NetworkManager.Settings.Connection.GetSettings", 0).Store(&settings)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *SettingsConnection) GetSecrets(setting_name string) (secrets map[string]map[string]dbus.Variant, _err error) {
	_err = obj.core.Call("org.freedesktop.NetworkManager.Settings.Connection.GetSecrets", 0, setting_name).Store(&secrets)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *SettingsConnection) ConnectUpdated(callback func()) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.NetworkManager.Settings.Connection',sender='"+obj.DestName+"',member='Updated'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.Settings.Connection.Updated" || 0 != len(v.Body) {
				continue
			}

			callback()
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

func (obj *SettingsConnection) ConnectRemoved(callback func()) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.NetworkManager.Settings.Connection',sender='"+obj.DestName+"',member='Removed'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.Settings.Connection.Removed" || 0 != len(v.Body) {
				continue
			}

			callback()
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

func NewSettingsConnection(destName string, path dbus.ObjectPath) (*SettingsConnection, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &SettingsConnection{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	runtime.SetFinalizer(obj, func(_obj *SettingsConnection) { DestroySettingsConnection(_obj) })
	return obj, nil
}
