/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package networkmanager

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type Settings struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	Hostname  *dbusPropertySettingsHostname
	CanModify *dbusPropertySettingsCanModify
}

func (obj *Settings) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *Settings) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroySettings(obj *Settings) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.Hostname.Reset()
	obj.CanModify.Reset()
}

func (obj *Settings) ListConnections() (connections []dbus.ObjectPath, _err error) {
	_err = obj.core.Call("org.freedesktop.NetworkManager.Settings.ListConnections", 0).Store(&connections)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Settings) GetConnectionByUuid(uuid string) (connection dbus.ObjectPath, _err error) {
	_err = obj.core.Call("org.freedesktop.NetworkManager.Settings.GetConnectionByUuid", 0, uuid).Store(&connection)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Settings) AddConnection(connection map[string]map[string]dbus.Variant) (path dbus.ObjectPath, _err error) {
	_err = obj.core.Call("org.freedesktop.NetworkManager.Settings.AddConnection", 0, connection).Store(&path)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Settings) SaveHostname(hostname string) (_err error) {
	_err = obj.core.Call("org.freedesktop.NetworkManager.Settings.SaveHostname", 0, hostname).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Settings) ConnectPropertiesChanged(callback func(properties map[string]dbus.Variant)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.NetworkManager.Settings',sender='"+obj.DestName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.Settings.PropertiesChanged" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*map[string]dbus.Variant)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(map[string]dbus.Variant))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

func (obj *Settings) ConnectNewConnection(callback func(connection dbus.ObjectPath)) func() {
	__conn.BusObject().Call("org.freedesktop.DBus.AddMatch", 0,
		"type='signal',path='"+string(obj.Path)+"', interface='org.freedesktop.NetworkManager.Settings',sender='"+obj.DestName+"',member='NewConnection'")
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.NetworkManager.Settings.NewConnection" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(dbus.ObjectPath))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertySettingsHostname struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertySettingsHostname) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Settings.Hostname is not writable")
}

func (this *dbusPropertySettingsHostname) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertySettingsHostname) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Settings", "Hostname").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:Hostname error:", err, "at org.freedesktop.NetworkManager.Settings")
		return *new(string)
	}
}
func (this *dbusPropertySettingsHostname) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertySettingsCanModify struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertySettingsCanModify) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.NetworkManager.Settings.CanModify is not writable")
}

func (this *dbusPropertySettingsCanModify) Get() bool {
	return this.GetValue().(bool)
}
func (this *dbusPropertySettingsCanModify) GetValue() interface{} /*bool*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.NetworkManager.Settings", "CanModify").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool)
	} else {
		fmt.Println("dbusProperty:CanModify error:", err, "at org.freedesktop.NetworkManager.Settings")
		return *new(bool)
	}
}
func (this *dbusPropertySettingsCanModify) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

func NewSettings(destName string, path dbus.ObjectPath) (*Settings, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &Settings{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.Hostname = &dbusPropertySettingsHostname{&property.BaseObserver{}, core}
	obj.CanModify = &dbusPropertySettingsCanModify{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.NetworkManager.Settings',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.NetworkManager.Settings" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "Hostname" {
						obj.Hostname.Notify()

					} else if key == "CanModify" {
						obj.CanModify.Notify()
					}
				}
			} else if v.Name == "org.freedesktop.NetworkManager.Settings.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "Hostname" {
						obj.Hostname.Notify()

					} else if key == "CanModify" {
						obj.CanModify.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *Settings) { DestroySettings(_obj) })
	return obj, nil
}
