/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package udisks2

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type PartitionTable struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	Type *dbusPropertyPartitionTableType
}

func (obj *PartitionTable) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *PartitionTable) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyPartitionTable(obj *PartitionTable) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.Type.Reset()
}

func (obj *PartitionTable) CreatePartition(offset uint64, size uint64, type_ string, name string, options map[string]dbus.Variant) (created_partition dbus.ObjectPath, _err error) {
	_err = obj.core.Call("org.freedesktop.UDisks2.PartitionTable.CreatePartition", 0, offset, size, type_, name, options).Store(&created_partition)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

type dbusPropertyPartitionTableType struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyPartitionTableType) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.UDisks2.PartitionTable.Type is not writable")
}

func (this *dbusPropertyPartitionTableType) Get() string {
	return this.GetValue().(string)
}
func (this *dbusPropertyPartitionTableType) GetValue() interface{} /*string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.UDisks2.PartitionTable", "Type").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string)
	} else {
		fmt.Println("dbusProperty:Type error:", err, "at org.freedesktop.UDisks2.PartitionTable")
		return *new(string)
	}
}
func (this *dbusPropertyPartitionTableType) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

func NewPartitionTable(destName string, path dbus.ObjectPath) (*PartitionTable, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &PartitionTable{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.Type = &dbusPropertyPartitionTableType{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.UDisks2.PartitionTable',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.UDisks2.PartitionTable" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "Type" {
						obj.Type.Notify()
					}
				}
			} else if v.Name == "org.freedesktop.UDisks2.PartitionTable.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "Type" {
						obj.Type.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *PartitionTable) { DestroyPartitionTable(_obj) })
	return obj, nil
}
