/*This file is automatically generated by pkg.linuxdeepin.com/dbus-generator. Don't edit it*/
package mpris

import "pkg.linuxdeepin.com/lib/dbus"
import "pkg.linuxdeepin.com/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type Playlists struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	PlaylistCount  *dbusPropertyPlaylistsPlaylistCount
	Orderings      *dbusPropertyPlaylistsOrderings
	ActivePlaylist *dbusPropertyPlaylistsActivePlaylist
}

func (obj *Playlists) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *Playlists) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyPlaylists(obj *Playlists) {
	obj.signalsLocker.Lock()
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signalsLocker.Unlock()

	obj.PlaylistCount.Reset()
	obj.Orderings.Reset()
	obj.ActivePlaylist.Reset()
}

func (obj *Playlists) ActivatePlaylist(PlaylistId dbus.ObjectPath) (_err error) {
	_err = obj.core.Call("org.mpris.MediaPlayer2.Playlists.ActivatePlaylist", 0, PlaylistId).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Playlists) GetPlaylists(Index uint32, MaxCount uint32, Order string, ReverseOrder bool) (arg_4 [][]interface{}, _err error) {
	_err = obj.core.Call("org.mpris.MediaPlayer2.Playlists.GetPlaylists", 0, Index, MaxCount, Order, ReverseOrder).Store(&arg_4)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

type dbusPropertyPlaylistsPlaylistCount struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyPlaylistsPlaylistCount) SetValue(notwritable interface{}) {
	fmt.Println("org.mpris.MediaPlayer2.Playlists.PlaylistCount is not writable")
}

func (this *dbusPropertyPlaylistsPlaylistCount) Get() uint32 {
	return this.GetValue().(uint32)
}
func (this *dbusPropertyPlaylistsPlaylistCount) GetValue() interface{} /*uint32*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.mpris.MediaPlayer2.Playlists", "PlaylistCount").Store(&r)
	if err == nil && r.Signature().String() == "u" {
		return r.Value().(uint32)
	} else {
		fmt.Println("dbusProperty:PlaylistCount error:", err, "at org.mpris.MediaPlayer2.Playlists")
		return *new(uint32)
	}
}
func (this *dbusPropertyPlaylistsPlaylistCount) GetType() reflect.Type {
	return reflect.TypeOf((*uint32)(nil)).Elem()
}

type dbusPropertyPlaylistsOrderings struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyPlaylistsOrderings) SetValue(notwritable interface{}) {
	fmt.Println("org.mpris.MediaPlayer2.Playlists.Orderings is not writable")
}

func (this *dbusPropertyPlaylistsOrderings) Get() []string {
	return this.GetValue().([]string)
}
func (this *dbusPropertyPlaylistsOrderings) GetValue() interface{} /*[]string*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.mpris.MediaPlayer2.Playlists", "Orderings").Store(&r)
	if err == nil && r.Signature().String() == "as" {
		return r.Value().([]string)
	} else {
		fmt.Println("dbusProperty:Orderings error:", err, "at org.mpris.MediaPlayer2.Playlists")
		return *new([]string)
	}
}
func (this *dbusPropertyPlaylistsOrderings) GetType() reflect.Type {
	return reflect.TypeOf((*[]string)(nil)).Elem()
}

type dbusPropertyPlaylistsActivePlaylist struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyPlaylistsActivePlaylist) SetValue(notwritable interface{}) {
	fmt.Println("org.mpris.MediaPlayer2.Playlists.ActivePlaylist is not writable")
}

func (this *dbusPropertyPlaylistsActivePlaylist) Get() []interface{} {
	return this.GetValue().([]interface{})
}
func (this *dbusPropertyPlaylistsActivePlaylist) GetValue() interface{} /*[]interface {}*/ {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.mpris.MediaPlayer2.Playlists", "ActivePlaylist").Store(&r)
	if err == nil && r.Signature().String() == "(b(oss))" {
		return r.Value().([]interface{})
	} else {
		fmt.Println("dbusProperty:ActivePlaylist error:", err, "at org.mpris.MediaPlayer2.Playlists")
		return *new([]interface{})
	}
}
func (this *dbusPropertyPlaylistsActivePlaylist) GetType() reflect.Type {
	return reflect.TypeOf((*[]interface{})(nil)).Elem()
}

func NewPlaylists(destName string, path dbus.ObjectPath) (*Playlists, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &Playlists{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.PlaylistCount = &dbusPropertyPlaylistsPlaylistCount{&property.BaseObserver{}, core}
	obj.Orderings = &dbusPropertyPlaylistsOrderings{&property.BaseObserver{}, core}
	obj.ActivePlaylist = &dbusPropertyPlaylistsActivePlaylist{&property.BaseObserver{}, core}

	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.freedesktop.DBus.Properties',sender='"+destName+"',member='PropertiesChanged'")
	getBus().BusObject().Call("org.freedesktop.DBus.AddMatch", 0, "type='signal',path='"+string(path)+"',interface='org.mpris.MediaPlayer2.Playlists',sender='"+destName+"',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.mpris.MediaPlayer2.Playlists" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "PlaylistCount" {
						obj.PlaylistCount.Notify()

					} else if key == "Orderings" {
						obj.Orderings.Notify()

					} else if key == "ActivePlaylist" {
						obj.ActivePlaylist.Notify()
					}
				}
			} else if v.Name == "org.mpris.MediaPlayer2.Playlists.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "PlaylistCount" {
						obj.PlaylistCount.Notify()

					} else if key == "Orderings" {
						obj.Orderings.Notify()

					} else if key == "ActivePlaylist" {
						obj.ActivePlaylist.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *Playlists) { DestroyPlaylists(_obj) })
	return obj, nil
}
